# git.vim

[![](https://spacevim.org/img/build-with-SpaceVim.svg)](https://spacevim.org)

Use git in SpaceVim



<!-- vim-markdown-toc GFM -->

- [usage](#usage)
- [Screenshot](#screenshot)
- [Feedback](#feedback)

<!-- vim-markdown-toc -->

## usage

- `:Git add %`: stage current file.
- `:Git add .`: stage all files
- `:Git commit`: edit commit message
- `:Git push`: push to remote
- `:Git fetch`: fetch remotes
- `:Git checkout`: checkout branches
- `:Git log %`: view git log of current file
- `:Git config`: list all git config
- `:Git reflog`: manage reflog information
- `:Git branch`: list, create, or delete branches

## Screenshot

**`:Git status`**

![git-status](https://user-images.githubusercontent.com/13142418/70063320-85efb600-1622-11ea-9aad-88d8b5b0f6d6.png)

**`:Git commit`**

![git-commit](https://user-images.githubusercontent.com/13142418/70335089-96519c00-1881-11ea-9c96-84c32566a002.png)

**`:Git push`**

![git-push](https://user-images.githubusercontent.com/13142418/70335203-d0bb3900-1881-11ea-8bf3-85b248c20dae.png)

**`:Git push`** completion

![git-push-complete](https://user-images.githubusercontent.com/13142418/70384670-7de69c00-19bd-11ea-91fe-9e8ced9775db.gif)

**`:Git diff`**

![git-diff](https://user-images.githubusercontent.com/13142418/70369625-7c52a080-18f7-11ea-9ee9-a1ba499b3d1f.png)

**`:Git log`**

![git-log](https://user-images.githubusercontent.com/13142418/70444048-39015900-1ad4-11ea-9522-1711c0c67098.png)


## Feedback

This plugin is based on SpaceVim's API, make sure your SpaceVim is the latest version.

To report bug or request new features about git.vim, please send me email.

wsdjeg@outlook.com
